<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <title>Chapitre 7. Contrôle des erreurs du paquet</title>
    <link rel="stylesheet" type="text/css" href="debian.css"/>
    <meta name="generator" content="DocBook XSL Stylesheets V1.78.1"/>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
    <link rel="home" href="index.fr.html" title="Guide du nouveau responsable Debian"/>
    <link rel="up" href="index.fr.html" title="Guide du nouveau responsable Debian"/>
    <link rel="prev" href="build.fr.html" title="Chapitre 6. Construction du paquet"/>
    <link rel="next" href="update.fr.html" title="Chapitre 8. Mise à jour de paquet"/>
  </head>
  <body>
    <div class="navheader">
      <table width="100%" summary="Navigation header">
        <tr>
          <th colspan="3" align="center">Chapitre 7. Contrôle des erreurs du paquet</th>
        </tr>
        <tr>
          <td align="left"><a accesskey="p" href="build.fr.html"><img src="images/prev.png" alt="Précédent"/></a> </td>
          <th width="60%" align="center"> </th>
          <td align="right"> <a accesskey="n" href="update.fr.html"><img src="images/next.png" alt="Suivant"/></a></td>
        </tr>
      </table>
      <hr/>
    </div>
    <div class="chapter">
      <div class="titlepage">
        <div>
          <div>
            <h1 class="title"><a id="checkit"/>Chapitre 7. Contrôle des erreurs du paquet</h1>
          </div>
        </div>
      </div>
      <div class="toc">
        <p>
          <strong>Table des matières</strong>
        </p>
        <dl class="toc">
          <dt>
            <span class="section">
              <a href="checkit.fr.html#inadvent">7.1. Modifications suspectes</a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="checkit.fr.html#pinstall">7.2. Vérification de l'installation d'un paquet</a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="checkit.fr.html#pmaintscripts">7.3. Vérification des scripts du responsable d'un paquet</a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="checkit.fr.html#lintians">7.4. Utilisation de <code class="systemitem">lintian</code></a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="checkit.fr.html#debc">7.5. Commande <span class="command"><strong>debc</strong></span></a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="checkit.fr.html#debdiff">7.6. Commande <span class="command"><strong>debdiff</strong></span></a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="checkit.fr.html#interdiff">7.7. Commande <span class="command"><strong>interdiff</strong></span></a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="checkit.fr.html#mc">7.8. Commande <span class="command"><strong>mc</strong></span></a>
            </span>
          </dt>
        </dl>
      </div>
      <p>
Quelques techniques sont à connaître pour rechercher des erreurs sur le
paquet avant de l'envoyer sur les archives publiques.
</p>
      <p>
Il est aussi conseillé d'effectuer des essais sur une machine différente de
la vôtre. Vous devez observer de près chaque alerte ou erreur pour tous les
tests décrits ici.
</p>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="inadvent"/>7.1. Modifications suspectes</h2>
            </div>
          </div>
        </div>
        <p>
Si vous trouvez un nouveau fichier de correctif autocréé comme
<code class="filename">debian-changes-*</code> dans le répertoire
<code class="filename">debian/patches</code> après la construction de votre paquet
Debian non natif au format <code class="literal">3.0 (quilt)</code>, il y a des
chances que vous ayez accidentellement modifié quelques fichiers ou que le
script de construction ait modifié les sources amont. Si c'est de votre
faute, corrigez votre erreur. Si c'est provoqué par le script de
construction, corrigez l'erreur à la racine avec
<span class="command"><strong>dh-autoreconf</strong></span> comme en <a class="xref" href="dreq.fr.html#customrules" title="4.4.3. Personnalisation du fichier rules">Section 4.4.3, « Personnalisation du fichier <code class="filename">rules</code> »</a> ou
contournez-la avec <code class="filename">source/options</code> comme en <a class="xref" href="dother.fr.html#sourceopt" title="5.25. source/options">Section 5.25, « <code class="filename">source/options</code> »</a>.
</p>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="pinstall"/>7.2. Vérification de l'installation d'un paquet</h2>
            </div>
          </div>
        </div>
        <p>
Vous devez essayer votre paquet pour vérifier qu'il s'installe sans
problème. La commande <span class="citerefentry"><span class="refentrytitle">debi</span>(1)</span> vous permet d'essayer
l'installation de tout paquet binaire créé.
</p>
        <pre class="screen">
$ sudo debi gentoo_0.9.12-1_i386.changes
</pre>
        <p>
Pour éviter les problèmes d'installation sur différents systèmes, vous devez
vérifier qu'il n'y a pas de nom de fichier en conflit avec ceux existants
dans d'autres paquets à l'aide du fichier
<code class="filename">Contents-<em class="replaceable"><code>i386</code></em></code> téléchargé
depuis l'archive Debian. La commande <span class="command"><strong>apt-file</strong></span> peut être
pratique pour cela. S'il existe des collisions, veuillez prendre les mesures
nécessaires pour éviter ces vrais problèmes : en renommant le fichier, en
déplaçant le fichier commun dans un paquet différent dont plusieurs paquets
peuvent dépendre, en utilisant le mécanisme d'alternatives (consultez
<span class="citerefentry"><span class="refentrytitle">update-alternatives</span>(1)</span>) en coordination avec les
responsables de l'autre paquet concerné, ou encore en déclarant une relation
de <code class="literal">Conflicts</code> dans le fichier
<code class="filename">debian/control</code>.
</p>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="pmaintscripts"/>7.3. Vérification des scripts du responsable d'un paquet</h2>
            </div>
          </div>
        </div>
        <p>
Tous les scripts du responsable, (c'est-à-dire les fichiers
<code class="filename">preinst</code>, <code class="filename">prerm</code>,
<code class="filename">postinst</code> et <code class="filename">postrm</code>), sont
difficiles à écrire correctement, à moins qu'ils n'aient été générés
automatiquement par les programmes <code class="systemitem">debhelper</code>. Ne les utilisez donc pas si vous êtes
un responsable débutant (consultez <a class="xref" href="dother.fr.html#maintscripts" title="5.19. {post,pre}{inst,rm}">Section 5.19, « <code class="filename">{post,pre}{inst,rm}</code> »</a>).
</p>
        <p>
Si le paquet utilise des scripts du responsable non triviaux, veuillez les
essayer non seulement pour le processus d'installation, mais aussi les
processus de suppression, purge et mise à niveau. De nombreux bogues dans
les scripts du responsable surviennent lors de la suppression et de la
purge. Utilisez la commande <span class="command"><strong>dpkg</strong></span> comme ceci pour les
essayer :
</p>
        <pre class="screen">
$ sudo dpkg -r gentoo
$ sudo dpkg -P gentoo
$ sudo dpkg -i gentoo_<em class="replaceable"><code>version</code></em>-<em class="replaceable"><code>révision</code></em>_<em class="replaceable"><code>i386</code></em>.deb
</pre>
        <p>
Les séquences suivantes devraient être essayées :
</p>
        <div class="itemizedlist">
          <ul class="itemizedlist">
            <li class="listitem">
              <p>
installation de la version précédente (si elle existe) ;
</p>
            </li>
            <li class="listitem">
              <p>
mise à niveau depuis la version précédente ;
</p>
            </li>
            <li class="listitem">
              <p>
dégradation (« downgrade ») à la version précédente (optionnel) ;
</p>
            </li>
            <li class="listitem">
              <p>
purge ;
</p>
            </li>
            <li class="listitem">
              <p>
installation du nouveau paquet ;
</p>
            </li>
            <li class="listitem">
              <p>
suppression (« remove ») du paquet ;
</p>
            </li>
            <li class="listitem">
              <p>
installation du paquet, encore ;
</p>
            </li>
            <li class="listitem">
              <p>
purge ;
</p>
            </li>
          </ul>
        </div>
        <p>
Pour votre premier paquet, vous devriez créer des paquets factices avec
différentes versions pour essayer votre paquet à l'avance et éviter des
problèmes par la suite.
</p>
        <p>
Gardez à l'esprit que si votre paquet a déjà été publié avec Debian, des
gens vont mettre à jour ce paquet à partir de la version qui était dans la
publication Debian précédente. N’oubliez pas d'essayer aussi les mises à
jour à partir de cette version.
</p>
        <p>
Même si la réinstallation vers une version antérieure n'est pas
officiellement gérée, il est préférable de la permettre.
</p>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="lintians"/>7.4. Utilisation de <code class="systemitem">lintian</code></h2>
            </div>
          </div>
        </div>
        <p>
Exécutez <span class="citerefentry"><span class="refentrytitle">lintian</span>(1)</span> sur le fichier
<code class="filename">.changes</code>. La commande <span class="command"><strong>lintian</strong></span>
exécute de nombreux scripts de tests pour vérifier la plupart des erreurs
habituelles d'empaquetage. <a href="#ftn.idp39831040" class="footnote" id="idp39831040"><sup class="footnote">[77]</sup></a>
</p>
        <pre class="screen">
$ lintian -i -I --show-overrides gentoo_0.9.12-1_i386.changes
</pre>
        <p>
Bien sûr, remplacez le nom de fichier par celui du fichier
<code class="filename">.changes</code> créé pour votre paquet. La sortie de la
commande <span class="command"><strong>lintian</strong></span> utilise les balises suivants :
</p>
        <div class="itemizedlist">
          <ul class="itemizedlist">
            <li class="listitem">
              <p>
<code class="literal">E:</code> pour erreur ; une violation certaine de la Charte ou
erreur d'empaquetage ;
</p>
            </li>
            <li class="listitem">
              <p>
<code class="literal">W:</code> pour avertissement ; une violation possible de la
Charte ou erreur d'empaquetage ;
</p>
            </li>
            <li class="listitem">
              <p>
<code class="literal">I:</code> pour information ; une information sur certains
aspects d'empaquetage ;
</p>
            </li>
            <li class="listitem">
              <p>
<code class="literal">N:</code> pour note ; un message détaillé pour vous aider à
déboguer ;
</p>
            </li>
            <li class="listitem">
              <p>
<code class="literal">O:</code> pour ignoré ; un message ignoré par le fichier
<code class="filename">lintian-overrides</code> mais affiché avec le paramètre
<code class="literal">--show-overrides</code>.
</p>
            </li>
          </ul>
        </div>
        <p>
En cas d'avertissements, mettez au point le paquet pour les éviter ou
vérifiez qu'ils sont infondés. S'ils sont infondés, configurez les fichiers
<code class="filename">lintian-overrides</code> comme décrit en <a class="xref" href="dother.fr.html#lintian" title="5.14. {paquet.,source/}lintian-overrides">Section 5.14, « <code class="filename">{<em class="replaceable"><code>paquet</code></em>.,source/}lintian-overrides</code> »</a>.
</p>
        <p>
Vous pouvez reconstruire le paquet avec <span class="command"><strong>dpkg-buildpackage</strong></span>
et lancer <span class="command"><strong>lintian</strong></span> en une seule commande, si vous utilisez
<span class="citerefentry"><span class="refentrytitle">debuild</span>(1)</span> ou <span class="citerefentry"><span class="refentrytitle">pdebuild</span>(1)</span>.
</p>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="debc"/>7.5. Commande <span class="command"><strong>debc</strong></span></h2>
            </div>
          </div>
        </div>
        <p>
La commande <span class="citerefentry"><span class="refentrytitle">debc</span>(1)</span> permet d'énumérer les fichiers du
paquet Debian binaire.
</p>
        <pre class="screen">
$ debc <em class="replaceable"><code>paquet</code></em>.changes
</pre>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="debdiff"/>7.6. Commande <span class="command"><strong>debdiff</strong></span></h2>
            </div>
          </div>
        </div>
        <p>
La commande <span class="citerefentry"><span class="refentrytitle">debdiff</span>(1)</span> peut comparer les contenus de
fichiers entre deux paquets Debian source
</p>
        <pre class="screen">
$ debdiff <em class="replaceable"><code>ancien-paquet</code></em>.dsc <em class="replaceable"><code>nouveau-paquet</code></em>.dsc
</pre>
        <p>
La commande <span class="citerefentry"><span class="refentrytitle">debdiff</span>(1)</span> permet aussi de comparer les listes
de fichiers entre deux ensembles de paquets Debian binaires.
</p>
        <pre class="screen">
$ debdiff <em class="replaceable"><code>ancien-paquet</code></em>.changes <em class="replaceable"><code>nouveau-paquet</code></em>.changes
</pre>
        <p>
Ces commandes sont utiles pour identifier ce qui a été modifié dans les
paquets source et pour vérifier d'éventuelles modifications faites par
inadvertance lors de la mise à jour des paquets binaires, comme par exemple
des fichiers déplacés ou enlevés involontairement.
</p>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="interdiff"/>7.7. Commande <span class="command"><strong>interdiff</strong></span></h2>
            </div>
          </div>
        </div>
        <p>
Vous pouvez comparer deux fichiers <code class="filename">diff.gz</code> avec la
commande <span class="citerefentry"><span class="refentrytitle">interdiff</span>(1)</span>. C'est utile pour vérifier
qu'aucune modification involontaire n'a été effectuée sur les sources par le
responsable en mettant à jour les paquets à l'ancien format source
<code class="literal">1.0</code>.
</p>
        <pre class="screen">
$ interdiff -z <em class="replaceable"><code>ancien-paquet</code></em>.diff.gz <em class="replaceable"><code>nouveau-paquet</code></em>.diff.gz
</pre>
        <p>
Le nouveau format source <code class="literal">3.0</code> garde les modifications dans
plusieurs fichiers de correctifs comme décrit en <a class="xref" href="dother.fr.html#patches" title="5.26. patches/*">Section 5.26, « <code class="filename">patches/*</code> »</a>. Vous pouvez aussi suivre les modifications de tous les
fichiers <code class="filename">debian/patches/*</code> en utilisant
<span class="command"><strong>interdiff</strong></span>.
</p>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="mc"/>7.8. Commande <span class="command"><strong>mc</strong></span></h2>
            </div>
          </div>
        </div>
        <p>
Toutes ces opérations d'inspection de fichier peuvent être transformées en
un processus intuitif avec un gestionnaire de fichiers comme <span class="citerefentry"><span class="refentrytitle">mc</span>(1)</span>
qui vous permet de consulter non seulement le contenu des fichiers paquet
<code class="filename">*.deb</code>, mais aussi les fichiers
<code class="filename">*.udeb</code>, <code class="filename">*.debian.tar.gz</code>,
<code class="filename">*.diff.gz</code> et <code class="filename">*.orig.tar.gz</code>.
</p>
        <p>
Soyez attentif aux fichiers inutiles ou de taille nulle, dans les paquets
binaires et source. Souvent les fichiers inutiles ne sont pas nettoyés
correctement ; adaptez le fichier <code class="filename">rules</code> pour compenser.
</p>
      </div>
      <div class="footnotes">
        <br/>
        <hr/>
        <div id="ftn.idp39831040" class="footnote">
          <p><a href="#idp39831040" class="para"><sup class="para">[77] </sup></a> Il n'est pas nécessaire d'ajouter le paramètre <code class="literal">-i -I
--show-overrides</code> à <span class="command"><strong>lintian</strong></span> si vous avez
personnalisé <code class="filename">/etc/devscripts.conf</code> ou
<code class="filename">~/.devscripts</code> comme décrit en <a class="xref" href="build.fr.html#debuild" title="6.3. Commande debuild">Section 6.3, « Commande <span class="command"><strong>debuild</strong></span> »</a>.
</p>
        </div>
      </div>
    </div>
    <div class="navfooter">
      <hr/>
      <table width="100%" summary="Navigation footer">
        <tr>
          <td align="left"><a accesskey="p" href="build.fr.html"><img src="images/prev.png" alt="Précédent"/></a> </td>
          <td align="center"> </td>
          <td align="right"> <a accesskey="n" href="update.fr.html"><img src="images/next.png" alt="Suivant"/></a></td>
        </tr>
        <tr>
          <td align="left" valign="top">Chapitre 6. Construction du paquet </td>
          <td align="center">
            <a accesskey="h" href="index.fr.html">
              <img src="images/home.png" alt="Sommaire"/>
            </a>
          </td>
          <td align="right" valign="top"> Chapitre 8. Mise à jour de paquet</td>
        </tr>
      </table>
    </div>
  </body>
</html>
